
//--------------------------FX5 edited by FOREXflash------------------------------


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_color4 DodgerBlue

//----
#define arrowsDisplacement 0.0001
//---- input parameters
string separator1 = "*** MACD Settings ***";
int    RSI_period = 13;
int    RSI_price = 0;
extern int    fastEMA = 12;
extern int    slowEMA = 36;
extern int    signalSMA = 9;
string separator2 = "*** Indicator Settings ***";
bool   drawIndicatorTrendLines = true;
bool   drawPriceTrendLines = true;
bool   displayAlert = false;
//---- buffers
double bullishDivergence[];
double bearishDivergence[];
double MACD[];
double MACDsignal[];
//double bullDiv[];
//double bearDiv[];

//----
static datetime lastAlertTime;
static string   indicatorName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexStyle(3, DRAW_LINE);
//   SetIndexStyle(4, DRAW_ARROW);
//   SetIndexStyle(5, DRAW_ARROW);
   
//----   
   SetIndexBuffer(0, bullishDivergence);
   SetIndexBuffer(1, bearishDivergence);
   SetIndexBuffer(2, MACD);
   SetIndexBuffer(3, MACDsignal);
//   SetIndexBuffer(4, bullDiv);
//   SetIndexBuffer(5, bearDiv);
      
//----   
   SetIndexArrow(0, 233);
   SetIndexArrow(1, 234);
//   SetIndexArrow(4, 233);
//   SetIndexArrow(5, 234);
//----
   indicatorName = "Divergence MACD (" + fastEMA + ", " + slowEMA + ", "
                     + signalSMA + ")";
   SetIndexDrawBegin(3, signalSMA);
   IndicatorDigits(Digits + 2);
   IndicatorShortName(indicatorName);

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 19) != "MACD_DivergenceLine")
           continue;
       ObjectDelete(label);   
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int countedBars = IndicatorCounted();
   if(countedBars < 0)
       countedBars = 0;
   CalculateIndicator(countedBars);
//---- 
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateIndicator(int countedBars)
  {
   for(int i = Bars - countedBars; i >= 0; i--)
     {
       CalculateMACD(i);
       CatchBullishDivergence(i+2);
       CatchBearishDivergence(i+2);
     }              
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateMACD(int i)
  {
   MACD[i] = iMACD(Symbol(), 0, fastEMA, slowEMA, signalSMA, 0, 0, i); 
   //MACD[i] = iRSI(Symbol(),0,RSI_period,RSI_price,i);
   
   MACDsignal[i]=iMACD(Symbol(),0,fastEMA,slowEMA,signalSMA, 0, 1, i); 
   //MACDsignal[i] = iRSI(Symbol(),0,RSI_period,RSI_price,i);        
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CatchBullishDivergence(int shift)
  {
   if(IsIndicatorTrough(shift) == false)
       return;  
   int currentTrough = shift;
   int lastTrough = GetIndicatorLastTrough(shift);
//----   
   if(MACD[currentTrough] > MACD[lastTrough] && 
      Low[currentTrough] < Low[lastTrough])
     {
       bullishDivergence[currentTrough] =  MACD[currentTrough] - arrowsDisplacement;  
       //bullDiv[currentTrough] =  Low[currentTrough];
    
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              Low[currentTrough], 
                              Low[lastTrough], Lime, STYLE_SOLID);
    
       if(drawIndicatorTrendLines == true)
          DrawIndicatorTrendLine(Time[currentTrough], 
                                 Time[lastTrough], 
                                 MACD[currentTrough],
                                 MACD[lastTrough], 
                                 Lime, STYLE_SOLID);
 
       if(displayAlert == true)
          DisplayAlert("Classical bullish divergence on: ", 
                        currentTrough);  
     }
//---- 
/*  
   if(MACD[currentTrough] < MACD[lastTrough] && 
      Close[currentTrough] > Close[lastTrough])
     {
       bullishDivergence[currentTrough] = MACD[currentTrough] - 
                                          arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              Close[currentTrough], 
                              Close[lastTrough], Lime, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)                            
           DrawIndicatorTrendLine(Time[currentTrough], 
                                  Time[lastTrough], 
                                  MACD[currentTrough],
                                  MACD[lastTrough], 
                                  Lime, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("Reverse bullish divergence on: ", 
                        currentTrough);   
     } 
*/          
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CatchBearishDivergence(int shift)
  {
   if(IsIndicatorPeak(shift) == false)
       return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift);
//----   
   if(MACD[currentPeak] < MACD[lastPeak] && 
      High[currentPeak] > High[lastPeak])
     {
       bearishDivergence[currentPeak] =  MACD[currentPeak] + arrowsDisplacement;  
       //bearDiv[currentPeak] =  High[currentPeak];
      
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              High[currentPeak], 
                              High[lastPeak], Red, STYLE_SOLID);
                            
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  MACD[currentPeak],
                                  MACD[lastPeak], Red, STYLE_SOLID);

       if(displayAlert == true)
           DisplayAlert("Classical bearish divergence on: ", 
                        currentPeak);  
     }

/*     
   if(MACD[currentPeak] > MACD[lastPeak] && 
      Close[currentPeak] < Close[lastPeak])
     {
       bearishDivergence[currentPeak] = MACD[currentPeak] + 
                                        arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              Close[currentPeak], 
                              Close[lastPeak], Red, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  MACD[currentPeak],
                                  MACD[lastPeak], Red, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("Reverse bearish divergence on: ", 
                        currentPeak);   
     }
*/        
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorPeak(int shift)
  {
   if(MACD[shift] > MACD[shift+1]
     && MACD[shift] > MACD[shift+2] && MACD[shift] > MACD[shift-1] && MACD[shift] > MACD[shift-2]) 
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorTrough(int shift)
  {
   if(MACD[shift] < MACD[shift+1]
      && MACD[shift] < MACD[shift+2] && MACD[shift] < MACD[shift-1] && MACD[shift] < MACD[shift-2])
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastPeak(int shift)
  {
   for(int i = shift + 4; i < Bars; i++)
     {
      if(MACDsignal[i]>=MACDsignal[i+1]&&MACDsignal[i]>=MACDsignal[i+2]&&
         MACDsignal[i]>=MACDsignal[i-1] &&MACDsignal[i]>=MACDsignal[i-2])
         {
           for(int j = i; j < Bars; j++)
             {
               if(MACD[j] >= MACD[j+1] && MACD[j] > MACD[j+2] &&
                  MACD[j] >= MACD[j-1]  && MACD[j] > MACD[j-2])
                   return(j);
             }
         }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastTrough(int shift)
  {
    for(int i = shift + 4; i < Bars; i++)
      {
       if(MACDsignal[i]<=MACDsignal[i+1]&&MACDsignal[i]<=MACDsignal[i+2]&&
          MACDsignal[i]<=MACDsignal[i-1]) //&&MACDsignal[i]<=MACDsignal[i-2])
          {
            for (int j = i; j < Bars; j++)
              {
                if(MACD[j] <= MACD[j+1] && MACD[j] < MACD[j+2] &&
                   MACD[j] <= MACD[j-1]) // && MACD[j] < MACD[j-2])
                    return(j);
              }
          }
      }
    return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DisplayAlert(string message, int shift)
  {
   if(shift <= 2 && Time[shift] != lastAlertTime)
     {
       lastAlertTime = Time[shift];
       Alert(message, Symbol(), " , ", Period(), " minutes chart");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawPriceTrendLine(datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, double style)
  {
   string label = "MACD_DivergenceLine" + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawIndicatorTrendLine(datetime x1, datetime x2, double y1, 
                            double y2, color lineColor, double style)
  {
   int indicatorWindow = WindowFind(indicatorName);
   if(indicatorWindow < 0)
       return;
   string label = "MACD_DivergenceLine_" + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, indicatorWindow, x1, y1, x2, y2, 
                0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+



